        LIST    P=16C84
        LIST    C=132
        LIST    N=55
        LIST    F=INHX8M

        TITLE   'ISO_7816_INTERFACE_DEVICE'

;**************************************************************************
;* PROGRAMMER           : THOMAS & HARALD                                 *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               :                                                 *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          : ISO 7816 INTERFACE DEVICE                       *
;**************************************************************************

        INCLUDE "PIC84V4.H"

        PAGE

        ORG     PIC84
        GOTO    MAIN

        ORG     004H
        RETFIE

;**************************************************************************

ANSWER_TO_RESET_SEQUENCE                ;   ;
        ADDWF   PC,SAME                 ; 1 ;

        RETLW   03FH                    ; 2 ;
        RETLW   0FAH                    ; 2 ;
        RETLW   011H                    ; 2 ;
        RETLW   025H                    ; 2 ;
        RETLW   000H                    ; 2 ;
        RETLW   000H                    ; 2 ;
        RETLW   001H                    ; 2 ;
        RETLW   0B0H                    ; 2 ;
        RETLW   002H                    ; 2 ;
        RETLW   000H                    ; 2 ;
        RETLW   000H                    ; 2 ;
        RETLW   04DH                    ; 2 ;
        RETLW   059H                    ; 2 ;
        RETLW   000H                    ; 2 ;
        RETLW   081H                    ; 2 ;
        RETLW   080H                    ; 2 ;
                                        ;   ;
;***************************************************************************

VALID_INSTRUCTIONS                      ; 1 ;
        ADDWF   PC,SAME                 ; 1 ;WRITE_INSTRUCTIONS:

        RETLW   000H                    ; 2 ;DUMMY INSTRUCTION_CODE
        RETLW   070H                    ; 2 ;INSTRUCTION_CODE 0X70
        RETLW   078H                    ; 2 ;INSTRUCTION_CODE 0X78
        RETLW   07AH                    ; 2 ;INSTRUCTION_CODE 0X7A
        RETLW   07CH                    ; 2 ;INSTRUCTION_CODE 0X7C
        RETLW   07EH                    ; 2 ;INSTRUCTION_CODE 0X7E
        RETLW   082H                    ; 2 ;INSTRUCTION_CODE 0X82
                                        ;   ;READ_INSTRUCTIONS:
        RETLW   072H                    ; 2 ;INSTRUCTION_CODE 0X72
        RETLW   074H                    ; 2 ;INSTRUCTION_CODE 0X74
        RETLW   076H                    ; 2 ;INSTRUCTION_CODE 0X76
        RETLW   080H                    ; 2 ;INSTRUCTION_CODE 0X80

;***************************************************************************
STRING
        MOVLW   000H                    ; 1 ;
        SUBWF   OSD_COUNT,WREG          ; 1 ;
        BTFSS   STATUS,Z                ; 1 ;
        GOTO    ANNOUNCE                ; 1 ;  IF ( OSD_COUNT == 00 )
                                        ;   ;
        BTFSS   FLAGS1,STR_HEADER       ; 1 ;
        GOTO    STRING1                 ; 2 ;
        RETLW   000H                    ; 2 ;   IF ( HEADER SENT ) RETURN (0)
STRING1 BSF     FLAGS1,STR_HEADER       ; 1 ;   IF FIRST TIME, RETURN (0X80)
        RETLW   080H                    ; 2 ;   AND SET STR_HEADER

;--------------------------------------------

ANNOUNCE
        MOVLW   019H                    ; 1 ;
        ADDWF   COUNTER,WREG            ; 1 ;
        ADDWF   PC,SAME                 ; 1 ;

        RETLW   080H                    ; 2 ;

        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;

        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;
        RETLW   ' '                     ; 2 ;

        MOVLW   00FH                    ; 1 ;
        ANDWF   C_MODE,SAME             ; 1 ;
        MOVF    C_MODE,WREG             ; 1 ;
        ADDLW   '0'                     ; 1 ;
        RETURN                          ; 1 ;

;***************************************************************************

DECIPHER_KEY
        ADDWF   PC,SAME                 ; 1 ;

        retlw   0x48
        retlw   0x9b
        retlw   0x4d
        retlw   0xa6
        retlw   0xf9
        retlw   0xd9
        retlw   0xdf
        retlw   0x6e
        retlw   0xac
        retlw   0x84
        retlw   0xfa
        retlw   0x8b
        retlw   0x2e
        retlw   0xb6
        retlw   0x76
        retlw   0x19
        retlw   0xc1
        retlw   0xb0
        retlw   0xa3
        retlw   0xbb
        retlw   0x0c
        retlw   0xfd
        retlw   0x70
        retlw   0x72
        retlw   0xca
        retlw   0x55
        retlw   0xef
        retlw   0xa0
        retlw   0x7f
        retlw   0xbf
        retlw   0x59
        retlw   0xad
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00
        retlw   0x00


        PAGE
;**************************************************************************

        ORG     0100H                   ;   ;

MAIN
        MOVLW   07FH                    ; 1 ;
        OPTION                          ; 1 ; PULL UP'S ON PORT B ENABLE
        MOVLW   000H                    ; 1 ;
        MOVWF   STATUS                  ; 1 ;

        MOVLW   TRI_A_MASK              ; 1 ;
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISA                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   LATCH_A_MASK            ; 1 ;
        MOVWF   PORT_A                  ; 1 ;   LATCHES LOW

        MOVLW   TRI_B_MASK              ; 1 ;
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   LATCH_B_MASK            ; 1 ;
        MOVWF   COM_PORT                ; 1 ;
                                        ;   ;
        BCF     FLAGS,CONVENTION        ; 1 ;PROTOCOL IN INVERSE_CONVENTION
        BCF     FLAGS,CHECKSUM_OK       ; 1 ;CHECKSUM_OK = 0
        BCF     FLAGS,DECODE_ON_WRITE   ; 1 ;DECODE_ON_WRITE = 0

        CLRF    FLAGS1                  ; 1 ;
        CLRF    WORK                    ; 1 ;
                                        ;   ;
        MOVLW   006H                    ; 1 ;
        MOVWF   OSD_COUNT               ; 1 ;OSD = ON
                                        ;   ;
        MOVLW   C_MODE_EE_ADR           ; 1 ; LOAD ADDRESS POINTER
        MOVWF   EEADR                   ; 1 ;
        BSF     STATUS,RP0              ; 1 ; PAGE 1
        BSF     EECON1,EE_RD            ; 1 ; RESTORE C_MODE
        BCF     STATUS,RP0              ; 1 ; PAGE 0
        MOVF    EEDATA,WREG             ; 1 ;
        MOVWF   C_MODE                  ; 1 ; SAVE DATA IN C_MODE
                                        ;   ;
        CALL    ANSWER_TO_RESET         ; 1 ;ANSWER TO RESET
                                        ;   ;
INFINITE_LOOP                           ; 1 ;
        BCF     FLAGS,CHCKSUM_REQUEST   ; 1 ;CHCKSUM_REQUEST = 0
        BCF     FLAGS,DECODE_ON_READ    ; 1 ;DECODE_ON_READ = 0
        BCF     FLAGS,SEND_REG_B1       ; 1 ;SEND_REG_B1 = 0
        BCF     FLAGS,STRING_REQUEST    ; 1 ;STRING_REQUEST = 0
        BCF     FLAGS1,STR_HEADER       ; 1 ;STR_HEADER = 0
        BCF     FLAGS1,READ_82          ; 1 ;READ_82 = 0
        BCF     FLAGS1,A82_HEADER       ; 1 ;A82_HEADER = 0
INSTRUCTION_LOOP                        ;   ;
        MOVLW   INSTRUCTION_CLASS       ; 1 ;RECEIVE_POINTER = INSTRUCTION_CLASS
        MOVWF   FSR                     ; 1 ;
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;INSTRUCTION_CLASS = RECEIVE_ISO_ASYNC ( );
        BTFSS   STATUS,C                ; 1 ;  IF ( ! C )
        GOTO    INFINITE_LOOP           ; 1 ;     CONTINUE
                                        ;   ;
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;INSTRUCTION_CODE = RECEIVE_ISO_ASYNC ( );
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;DUMMY1 = RECEIVE_ISO_ASYNC ( );
        DECF    FSR,SAME                ; 1 ;
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;DUMMY1 = RECEIVE_ISO_ASYNC ( );
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;COUNTER = RECEIVE_ISO_ASYNC ( );
        MOVLW   053H                    ; 1 ;
        SUBWF   INSTRUCTION_CLASS,WREG  ; 1 ;IF ( INSTRUCTION_CLASS ! = 0X53 )
        BTFSC   STATUS,Z                ;1/2;    {
        GOTO    INSTRUCTION_DECODING    ; 2 ;    SW1 = 0X6E;
        MOVLW   06EH                    ; 1 ;    INSTRUCTION_CLASS INVALID
        GOTO    TRANSMIT_SW1            ; 2 ;    BREAK;
                                        ;   ;    }
INSTRUCTION_DECODING                    ;   ;
        MOVLW   00AH                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
INSTR_DECODE_LOOP                       ; 1 ;FOR ( INDEX = 0X0A ; INDEX ; INDEX++ )
        MOVF    REG_00,WREG             ; 1 ;    {
        CALL    VALID_INSTRUCTIONS      ; 1 ;    IF ( INSTRUCTION_CODE ==
        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;         VALID_INSTRUCTIONS [ INDEX ] )
        BTFSC   STATUS,Z                ; 1 ;         {
        GOTO    INSTRUCTION_VALID       ; 1 ;         GOTO INSTRUCTION_VALID;
        DECFSZ  REG_00,SAME             ; 1 ;         }
        GOTO    INSTR_DECODE_LOOP       ; 1 ;    }
        MOVLW   06DH                    ; 1 ;INSTRUCTION_CODE NOT SUPPORTED
        GOTO    TRANSMIT_SW1            ; 1 ;

        PAGE

INSTRUCTION_VALID                       ;   ;
        MOVLW   007H                    ; 1 ;IF ( INDEX < 0X07 )
        SUBWF   REG_00,WREG             ; 1 ;    GOTO WRITE_MESSAGE
        BTFSS   STATUS,C                ;1/2;ELSE
        GOTO    WRITE_MESSAGE           ; 2 ;    GOTO READ_MESSAGE
                                        ;   ;
READ_MESSAGE                            ;   ;
        MOVLW   076H                    ; 1 ;
        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;
        BTFSS   STATUS,Z                ; 1 ;IF ( INSTRUCTION_CODE == 0X76 )
        GOTO    READ_MESS1              ; 2 ;
                                        ;   ;
        MOVLW   006H                    ; 1 ;  OSD_TIME = 006*RECEIVE 74
        MOVWF   OSD_COUNT               ; 1 ;  OSD = ON
                                        ;   ;
        MOVLW   00FH                    ; 1 ;
        INCF    C_MODE,SAME             ; 1 ;  INC C_MODE
        ANDWF   C_MODE,SAME             ; 1 ;
        MOVLW   009H                    ; 1 ;   !!!!! 0...8 !!!! 8X=MULTICHANNEL
        SUBWF   C_MODE,WREG             ; 1 ;
        BTFSC   STATUS,C                ; 1 ;
        CLRF    C_MODE                  ; 1 ;
        CALL    WREE_C_MODE             ; 1 ;
READ_MESS1                              ;   ;
        MOVLW   074H                    ; 1 ;
        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;
        BTFSS   STATUS,Z                ; 1 ;IF ( INSTRUCTION_CODE == 0X74 )
        GOTO    READ_MESS2              ; 2 ;
        MOVLW   000H                    ; 1 ;  IF ( OSD_COUNT != 0 )
        SUBWF   OSD_COUNT,WREG          ; 1 ;
        BTFSS   STATUS,Z                ; 1 ;
        DECFSZ  OSD_COUNT,SAME          ; 1 ;     OSD_COUNT--;
READ_MESS2
        MOVLW   074H                    ; 1 ;
        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;
        BTFSS   STATUS,Z                ; 1 ;IF ( INSTRUCTION_CODE == 0X74 )
        GOTO    TRANSMIT_PROCEDURE_BYTE ; 2 ;
        BSF     FLAGS,DECODE_ON_READ    ; 1 ;    DECODE_ON_READ = 1;
        BSF     FLAGS,DECODE_ON_WRITE   ; 1 ;    DECODE_ON_WRITE = 1;
        BSF     FLAGS,CHCKSUM_REQUEST   ; 1 ;    CHCKSUM_REQUEST = 1;
        BCF     FLAGS,CHECKSUM_OK       ; 1 ;    CHECKSUM_OK = 0;
TRANSMIT_PROCEDURE_BYTE                 ;   ;
        MOVF    INSTRUCTION_CODE,WREG   ; 1 ;ACCU = INSTRUCTION_CODE
        CALL    TRANSMIT_ISO_ASYNC      ; 1 ;SEND INSTRUCTION_CODE FOR ACKNOWLEDGE
        CLRF    CHECKSUM                ; 1 ;CHECKSUM = 0

        PAGE

READ_MESSAGE_LOOP_1                     ;   ;FOR (COUNTER=0X20;COUNTER;COUNTER--)
                                        ;   ;  {
        MOVLW   INSTRUCTION_CLASS       ; 1 ;
        MOVWF   FSR                     ; 1 ;
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;   INSTRUCTION_CLASS = RECEIVE_ISO_ASYNC ( );
        MOVF    READ_BYTE,WREG          ; 1 ;
        MOVWF   INSTRUCTION_CODE        ; 1 ;   INSTRUCTION_CODE  = READ_BYTE
        BTFSS   FLAGS,DECODE_ON_READ    ;1/2;   IF ( ! DECODE_ON_READ )
        GOTO    CONTINUE1               ; 2 ;     BREAK;
        MOVLW   006H                    ; 1 ;  IF ( COUNTER > 0X05 )
        SUBWF   COUNTER,WREG            ; 1 ;    {
        BTFSS   STATUS,C                ;1/2;
        GOTO    CONTINUE                ; 2 ;
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;    INSTRUCTION_CODE = RECEIVE_ISO_ASYNC ( );
        DECF    COUNTER,SAME            ; 1 ;
        CALL    RECEIVE_ISO_ASYNC       ; 1 ;    DUMMY1 = RECEIVE_ISO_ASYNC ( );
        DECF    COUNTER,SAME            ; 1 ;
        BSF     FLAGS,INC_REQUEST       ; 1 ;    INCREMENT_REQUEST = 1
        MOVLW   01EH                    ; 1 ;    IF ( COUNTER == 0X1E )
        SUBWF   COUNTER,WREG            ; 1 ;       {
        BTFSC   STATUS,Z                ;1/2;       CHECK_1 ( );
        CALL    CHECK_1                 ; 2 ;       }
        MOVLW   01BH                    ; 1 ;    IF ( COUNTER == 0X1B )
        SUBWF   COUNTER,WREG            ; 1 ;       {
        BTFSC   STATUS,Z                ;1/2;       CHECK_2 ( );
        CALL    CHECK_2                 ; 2 ;       }
        MOVLW   018H                    ; 1 ;    IF ( COUNTER == 0X18 )
        SUBWF   COUNTER,WREG            ; 1 ;       {
        BTFSC   STATUS,Z                ;1/2;       CHECK_3 ( );
        CALL    CHECK_3                 ; 2 ;       }
        MOVLW   003H                    ; 1 ;
        CALL    DECIPHER_N_BYTE         ; 2 ;    DECIPHER_3_BYTE;
        CLRF    REG_47                  ; 1 ;    REG_47 = 0X00
        GOTO    CONTINUE1               ; 2 ;    }
CONTINUE                                ;   ;  ELSE
        MOVF    REG_47,WREG             ; 1 ;    {
        MOVWF   INSTRUCTION_CLASS       ; 1 ;  >INSTR_CLASS>REG_47>Ŀ
        MOVF    INSTRUCTION_CODE,WREG   ; 1 ;  <
        MOVWF   REG_47                  ; 1 ;    REG_47 = INSTRUCTION_CLASS
        DECF    COUNTER,WREG            ; 1 ;
        BTFSC   STATUS,Z                ;1/2;    IF ( COUNTER != 0X01 )
        GOTO    CONTINUE1               ; 2 ;      {
        BCF     FLAGS,INC_REQUEST       ; 1 ;      INCREMENT_REQUEST = 0
        MOVLW   002H                    ; 1 ;      DECIPHER 2 BYTE
        CALL    DECIPHER_N_BYTE         ; 2 ;
        INCF    REG_B1_POINTER,SAME     ; 1 ;      REG_B1_POINTER ++;
        MOVLW   007H                    ; 1 ;      REG_B1_POINTER &= 0X07;
        ANDWF   REG_B1_POINTER,SAME     ; 1 ;      }
CONTINUE1                               ;   ;    }
        DECFSZ  COUNTER,SAME            ; 1 ;  }
        GOTO    READ_MESSAGE_LOOP_1     ; 1 ;IF ( CHCKSUM_REQUEST )
        BTFSS   FLAGS,CHCKSUM_REQUEST   ;1/2;  {
        GOTO    END_OF_MESSAGE          ; 2 ;  IF ( CHECKSUM == 0X00 )
        MOVF    CHECKSUM,SAME           ; 1 ;     {
        BTFSC   STATUS,Z                ;1/2;     CHECKSUM_OK = 1;
        BSF     FLAGS,CHECKSUM_OK       ; 1 ;     }
        GOTO    END_OF_MESSAGE          ; 1 ;  }

        PAGE

WRITE_MESSAGE                           ; 1 ;
        MOVF    INSTRUCTION_CODE,WREG   ; 1 ;ACCU = INSTRUCTION_CODE
        CALL    TRANSMIT_ISO_ASYNC      ; 1 ;SEND INSTRUCTION_CODE FOR ACKNOWLEDGE

        MOVLW   078H                    ; 1 ;IF ( INSTRUCTION_CODE == 0X78 )
        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;  {
        BTFSS   STATUS,Z                ;1/2;
        GOTO    WRITE_STRING            ; 2 ;
        BSF     FLAGS,SEND_REG_B1       ; 1 ;  SEND_REG_B1 = 1
        MOVF    REG_47,WREG             ; 1 ;  DECIPHER WITH REG_47
        MOVWF   INSTRUCTION_CLASS       ; 1 ;
        MOVLW   040H                    ; 1 ;
        BTFSC   FLAGS,DECODE_ON_WRITE   ;1/2;
        CALL    DECIPHER_BYTE           ; 2 ;  DECIPHER_64_BYTE;
        BCF     FLAGS,DECODE_ON_WRITE   ; 1 ;

WRITE_STRING                            ;   ;  }
        MOVLW   07AH                    ; 1 ;
        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;
        BTFSC   STATUS,Z                ; 1 ;
        BSF     FLAGS,STRING_REQUEST    ; 1 ;
        COMF    COUNTER,SAME            ; 1 ;2'S COMPLEMENT COUNTER
        INCF    COUNTER,SAME            ; 1 ;

WRITE_MESSAGE_LOOP                      ;   ;DO
        CLRW                            ; 1 ;    {
        BTFSC   FLAGS,STRING_REQUEST    ;1/2;
        CALL    STRING                  ; 2 ;    STRING_OUTPUT

        BTFSC   FLAGS,CHECKSUM_OK       ;1/2;
        BTFSS   FLAGS,SEND_REG_B1       ;1/2;
        GOTO    OUTPUT                  ; 2 ;
        MOVLW   ARRAY_REG_B1+8          ; 1 ;
        ADDWF   COUNTER,WREG            ; 1 ;
        MOVWF   FSR                     ; 1 ;
        MOVF    IND0,WREG               ; 1 ;
OUTPUT                                  ;   ;
        CALL    TRANSMIT_ISO_ASYNC      ; 2 ;    SEND_SINGLE_BYTE;
        INCFSZ  COUNTER,SAME            ;1/2;    }
        GOTO    WRITE_MESSAGE_LOOP      ; 2 ;WHILE ( -- COUNTER );
                                        ;   ;
END_OF_MESSAGE                          ; 1 ;END_OF_MESSAGE_SEQUENCE
        MOVLW   090H                    ; 1 ;SW1 = 0X90
TRANSMIT_SW1
        CALL    TRANSMIT_ISO_ASYNC      ; 1 ;TRANSMIT SW1
        MOVLW   000H                    ; 1 ;
        CALL    TRANSMIT_ISO_ASYNC      ; 1 ;TRANSMIT SW2
                                        ;   ;
        GOTO    INFINITE_LOOP           ; 1 ;
                                        ;   ;
        PAGE

;**************************************************************************
;* PROGRAMMER           : HARALD                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               : ANSWER_TO_RESET                                 *
;* USING                : REG_03,REG_04                                   *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

ANSWER_TO_RESET
        CLRF    REG_05                  ; 1 ;
ANSWER_TO_RESET_LOOP                    ; 1 ;
        MOVF    REG_05,WREG             ; 1 ;
        CALL    ANSWER_TO_RESET_SEQUENCE; 2 ;
        CALL    TRANSMIT_ISO_ASYNC      ; 2 ;
        INCF    REG_05,SAME             ; 1 ;
        BTFSS   REG_05,4                ;1/2;
        GOTO    ANSWER_TO_RESET_LOOP    ; 1 ;
        RETLW   0                       ; 2 ;

        PAGE

;**************************************************************************
;* PROGRAMMER           : HARALD                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               : CHECK_1                                         *
;* USING                : REG_00,REG_04,REG_05                            *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

CHECK_1
        CLRF    REG_B1_POINTER          ; 1 ;REG_B1_POINTER = 0X00
        CLRF    DEC_KEY_POINTER         ; 1 ;DECIPHER_KEY_POINTER = 0X00

        BCF     FLAGS1,DATA_HEAD        ; 1 ;DATA_HEADER = FALSE
        BTFSC   INSTRUCTION_CLASS,4     ; 1 ; TEST IF XXX1 XXXX
        BSF     FLAGS1,DATA_HEAD        ; 1 ;

        MOVLW   0E8H                    ; 1 ;
        SUBWF   INSTRUCTION_CLASS,WREG  ; 1 ;

        ANDLW   0EFH                    ; 1 ;MASK 0XE8 OR 0XF8

        BTFSS   STATUS,Z                ;1/2;IF ( ARRAY_REG_28 [ 0 ] != 0XE8 )
        BCF     FLAGS,DECODE_ON_READ    ; 1 ;    DECODE_ON_READ = 0
        BTFSS   STATUS,Z                ;1/2;IF ( ARRAY_REG_28 [ 0 ] != 0XE8 )
        BCF     FLAGS,DECODE_ON_WRITE   ; 1 ;    DECODE_ON_WRITE = 0;
        CALL    CLEAR_ARRAY_REG_B1      ; 2 ;CLEAR ARRAY REG_B1

;        MOVLW   033H                    ; 1 ;IF ( ARRAY_REG_28 [ 1 ] < 0X33 )
;        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;    DECIPHER_KEY_POINTER = 0X00;
;        CLRW                            ; 1 ;
;        BTFSC   STATUS,C                ;1/2;ELSE
;        MOVLW   008H                    ; 1 ;    DECIPHER_KEY_POINTER = 0X08;
;        MOVWF   DEC_KEY_POINTER         ; 1 ;
;        MOVLW   03BH                    ; 1 ;IF ( ARRAY_REG_28 [ 1 ] < 0X3B )
;        SUBWF   INSTRUCTION_CODE,WREG   ; 1 ;    DECIPHER_KEY_POINTER = 0X08;
;        MOVF    DEC_KEY_POINTER,WREG    ; 1 ;ELSE
;        BTFSC   STATUS,C                ;1/2;    DECIPHER_KEY_POINTER = 0X18;
;        MOVLW   018H                    ; 1 ;
;        MOVWF   DEC_KEY_POINTER         ; 1 ;
        RETLW   000H                    ; 2 ;


        PAGE

;**************************************************************************
;* PROGRAMMER           : HARALD                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               : CHECK_2                                         *
;* USING                : REG_00,REG_04,REG_05                            *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

CHECK_2
        BTFSC   FLAGS1,DATA_HEAD        ; 1 ;TEST IF DATA_HEADER == 0XF8
        GOTO    CHECK_ZERO_END          ; 2 ;   THEN SKIP TEST AND DECODE

        MOVF    INSTRUCTION_CODE,WREG   ; 1 ;W = ARRAY_REG_28 [ 4 ]
        IORWF   DUMMY1,WREG             ; 1 ;W |= ARRAY_REG_28 [ 5 ]
        BTFSS   STATUS,Z                ;1/2;
        GOTO    CHECK_ZERO_END          ; 2 ;

        CALL    CLEAR_ARRAY_REG_B1      ; 2 ;
        MOVLW   001H                    ; 1 ;
        MOVWF   ARRAY_REG_B1            ; 1 ;
        BCF     FLAGS,DECODE_ON_READ    ; 1 ;
        BCF     FLAGS,DECODE_ON_WRITE   ; 1 ;    DECODE_ON_WRITE = 0;
CHECK_ZERO_END                          ;   ;
        RETLW   000H                    ; 2 ;

        PAGE

;**************************************************************************
;* PROGRAMMER           : THOMAS                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               : CHECK_3                                         *
;* USING                : REG_00,REG_04,REG_05                            *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

CHECK_3
        MOVLW   TRI_B_MASK              ; 1 ;
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   LATCH_B_MASK            ; 1 ;
        MOVWF   COM_PORT                ; 1 ;

        BTFSC   SOLDPO2,SOLDPI2         ; 1 ; CHECK SOLDER 2
        GOTO    CHECK_31                ; 2 ; IF CLOSED -> == 0

        MOVLW   00FH                    ; 1 ; TEST FOR ID = 8
        ANDWF   INSTRUCTION_CLASS,WREG  ; 1 ;
        MOVWF   WORK                    ; 1 ;
        MOVLW   007H                    ; 1 ;
        ANDWF   WORK,WREG               ; 1 ; IF ( ID != 0X08 && ID != 0X00 )
        BTFSC   STATUS,Z                ;1/2;   GO_ON
        GOTO    WRONG_3                 ; 2 ;
CHECK_31
        SWAPF   C_MODE,WREG             ; 1 ;   MASK ID
        ANDWF   INSTRUCTION_CLASS,WREG  ; 1 ;
        BTFSC   STATUS,Z                ;1/2;
        GOTO    CHECK_3_END             ; 2 ;

WRONG_3
        CALL    CLEAR_ARRAY_REG_B1      ; 2 ;
        BCF     FLAGS,DECODE_ON_READ    ; 1 ;
        BCF     FLAGS,DECODE_ON_WRITE   ; 1 ;    DECODE_ON_WRITE = 0;
CHECK_3_END                             ;   ;
        RETLW   000H                    ; 2 ;

        PAGE

;**************************************************************************
;* PROGRAMMER           :                                                 *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               : CLEAR_ARRAY_REG_B1                              *
;* USING                :                                                 *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

CLEAR_ARRAY_REG_B1
        CLRF    ARRAY_REG_B1            ; 1 ;ARRAY_REG_B1 [ 0 ] = 0
        CLRF    ARRAY_REG_B1+1          ; 1 ;ARRAY_REG_B1 [ 1 ] = 0
        CLRF    ARRAY_REG_B1+2          ; 1 ;ARRAY_REG_B1 [ 2 ] = 0
        CLRF    ARRAY_REG_B1+3          ; 1 ;ARRAY_REG_B1 [ 3 ] = 0
        CLRF    ARRAY_REG_B1+4          ; 1 ;ARRAY_REG_B1 [ 4 ] = 0
        CLRF    ARRAY_REG_B1+5          ; 1 ;ARRAY_REG_B1 [ 5 ] = 0
        CLRF    ARRAY_REG_B1+6          ; 1 ;ARRAY_REG_B1 [ 6 ] = 0
        CLRF    ARRAY_REG_B1+7          ; 1 ;ARRAY_REG_B1 [ 7 ] = 0
        RETLW   000H                    ; 2 ;

        PAGE

;**************************************************************************
;* PROGRAMMER           : HARALD & THOMAS                                 *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               : DECIPHER_N_BYTE                                 *
;* USING                : REG_00,REG_01,REG_02,REG_03,FSR                 *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

        PAGE

DECIPHER_N_BYTE
        BTFSS   FLAGS,DECODE_ON_READ    ;1/2;
        RETLW   000H                    ; 2 ;
DECIPHER_BYTE                           ;   ;
        MOVWF   REG_03                  ; 1 ;N IN W
        MOVLW   INSTRUCTION_CLASS       ; 1 ;PLAINTEXT_POINTER = INSTRUCTION_CLASS
        MOVWF   REG_02                  ; 1 ;REG_02 = PLAINTEXT_POINTER
DECIPHER_LOOP                           ;   ;DO
        MOVF    REG_02,WREG             ; 1 ;  {
        MOVWF   FSR                     ; 1 ;  SFR = PLAINTEXT_POINTER
        MOVF    IND0,WREG               ; 1 ;  W = PLAINTEXT_BYTE
        MOVWF   REG_00                  ; 1 ;  SAVE PLAINTEXT_BYTE;
        MOVLW   ARRAY_REG_B1            ; 1 ;  W = & ARRAY_REG_B1 [ 0 ]
        ADDWF   REG_B1_POINTER,WREG     ; 1 ;  W = W + REG_B1_POINTER;
        MOVWF   FSR                     ; 1 ;  FSR = REG_B1_POINTER;
        INCF    REG_B1_POINTER,SAME     ; 1 ;  REG_B1_POINTER ++;
        MOVLW   007H                    ; 1 ;
        ANDWF   REG_B1_POINTER,SAME     ; 1 ;  REG_B1_POINTER &= 0X07;
        MOVF    REG_00,WREG             ; 1 ;  RESTORE_PLAINTEXT_BYTE;
        XORWF   IND0,SAME               ; 1 ;  ARRAY_REG_B1 [ FSR ] ^= PLAINTEXT_BYTE;
        SWAPF   IND0,WREG               ; 1 ;  W = SWAP ( ARRAY_REG_B1 [ FSR ] );
        ANDLW   00FH                    ; 1 ;  W = W & 0X0F;
        ADDWF   DEC_KEY_POINTER,WREG    ; 1 ;  W = W + DECIPHER_KEY_POINTER;
        CALL    DECIPHER_KEY            ; 2 ;  W = DECIPHER_KEY [ W ];
        MOVWF   REG_01                  ; 1 ;  SAVE W TEMPORARILY
        MOVF    IND0,WREG               ; 1 ;  W = ARRAY_REG_B1 [ FSR ];
        ANDLW   00FH                    ; 1 ;  W = W & 0X0F;
        IORLW   010H                    ; 1 ;  W = W + 0X10;
        ADDWF   DEC_KEY_POINTER,WREG    ; 1 ;  W = W + DECIPHER_KEY_POINTER;
        CALL    DECIPHER_KEY            ; 1 ;  W = DECIPHER_KEY [ W ];
        ADDWF   REG_01,SAME             ; 1 ;  REG_01 = W + REG_01
        COMF    REG_01,SAME             ; 1 ;  REG_01 = ~ REG_01;
        MOVF    REG_01,WREG             ; 1 ;  W = REG_01
        ADDWF   REG_01,SAME             ; 1 ;  REG_01 = REG_01 * 0X02;
        BTFSC   STATUS,C                ;1/2;
        INCF    REG_01,SAME             ; 1 ;  REG_01 += C;
        MOVF    REG_00,WREG             ; 1 ;  W = REG_00; ( PLAINTEXT_BYTE )
        ADDWF   REG_01,SAME             ; 1 ;  REG_01 += W;
        MOVF    REG_01,WREG             ; 1 ;  W = REG_01
        ADDWF   REG_01,SAME             ; 1 ;  REG_01 = REG_01 * 0X02;
        BTFSC   STATUS,C                ;1/2;
        INCF    REG_01,SAME             ; 1 ;  REG_01 += C;
        SWAPF   REG_01,SAME             ; 1 ;  REG_01 = SWAP ( REG_01 );
        MOVLW   ARRAY_REG_B1            ; 1 ;  W = & ARRAY_REG_B1 [ 0 ]
        ADDWF   REG_B1_POINTER,WREG     ; 1 ;  W = REG_B1_POINTER
        MOVWF   FSR                     ; 1 ;  FSR = REG_B1_POINTER
        MOVF    REG_01,WREG             ; 1 ;  W = REG_01
        XORWF   IND0,SAME               ; 1 ;  ARRAY_REG_B1 [ FSR ] ^= REG_01;
        BTFSC   FLAGS,INC_REQUEST       ;1/2;  IF ( INCREMENT_REQUEST )
        INCF    REG_02,SAME             ; 1 ;    {
        DECFSZ  REG_03,SAME             ;1/2;    REG_02 ++
        GOTO    DECIPHER_LOOP           ; 2 ;    }
        RETLW   000H                    ; 2 ;  }
                                        ;38;WHILE ( -- REG_03 );

        PAGE

;**************************************************************************
;* PROGRAMMER           : HARALD                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               :                                                 *
;* USING                : REG_00,REG_01,REG_02,REG_03(SEND_BYTE) PSW      *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;*XYZ                                                                     *
;**************************************************************************


;ASYNCHRONOUS COMMUNICATION CARD --> CONTROLLER
;**********************************************

; BIT TRANSMIT_ISO_ASYNC ( UNSIGNED CHAR SEND_BYTE )

TRANSMIT_ISO_ASYNC

        BCF     COM_PORT,ISOTXD         ; 1 ;LOW  ----> TXD LATCH
        MOVWF   SEND_BYTE               ; 1 ;
        MOVLW   00FH                    ; 1 ;RETRY_COUNTER (BYTE) = 15
        MOVWF   REG_02                  ; 1 ;
TRANSMIT_BYTE                           ;   ;
        MOVLW   004H                    ; 1 ;GUARDTIME = 5
        MOVWF   REG_01                  ; 1 ;
GUARDTIME_DELAY                         ;   ;
        MOVLW   01EH                    ; 1 ;FOR (COUNTER1 = 0X06;COUNTER1 != 0;COUNTER1--)
        MOVWF   REG_00                  ; 1 ;   {
BIT_DELAY                               ;   ;
        DECFSZ  REG_00,SAME             ;   ;   FOR (COUNTER = 0X1E;COUNTER != 0;COUNTER--);
        GOTO    BIT_DELAY               ;89;
        DECFSZ  REG_01,SAME             ;   ;
        GOTO    GUARDTIME_DELAY         ;94;
                                        ;   ;   } GUARDTIME * 94 - 1 [CYCLES]
        MOVLW   009H                    ; 1 ;BIT_COUNTER = 0X09
        MOVWF   REG_01                  ; 1 ;
        CLRF    PSW                     ; 1 ;PARITY CALCULATE REGISTER
        BTFSS   FLAGS,CONVENTION        ;1/2;IF ( INVERSE_CONVENTION )
                                        ;   ;    {
        COMF    SEND_BYTE,SAME          ; 1 ;    COMPLEMENT SEND_BYTE
                                        ;   ;    }
        BTFSS   FLAGS,CONVENTION        ;1/2;IF ( INVERSE_CONVENTION )
                                        ;   ;    {
        INCF    PSW,SAME                ; 1 ;    COMPLEMENT PARITY
                                        ;   ;    }
        BCF     STATUS,C                ; 1 ;PREPARE STARTBIT
        GOTO    BIT_OUTPUT              ; 2 ;STARTBIT --> I/O
                                        ;   ;FOR ( ;BIT_COUNTER != 0;BIT_COUNTER-- )
TRANSMIT_BIT                            ;   ;   {
        BTFSC   FLAGS,CONVENTION        ;1/2;
        RRF     SEND_BYTE,SAME          ; 1 ;   DIRECT_CONVENTION : ROTATE RIGHT
        BTFSS   FLAGS,CONVENTION        ;1/2;
        RLF     SEND_BYTE,SAME          ; 1 ;   INVERSE_CONVENTION : ROTATE LEFT
BIT_OUTPUT                              ;   ;
        BTFSC   STATUS,C                ;1/2;
        INCF    PSW,SAME                ; 1 ;   UPDATE_PARITY
        MOVLW   TRI_B_MASK & 0FFH       ; 1 ;   TXD = INPUT ( TRISTATE )
        BTFSS   STATUS,C                ;1/2;   OR
        MOVLW   TRI_B_MASK & 0FEH       ; 1 ;   TXD = OUTPUT  ( ACTIVE LOW )
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   019H                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
SEND_DATA_BIT_DELAY                     ;14;
        DECFSZ  REG_00,SAME             ;   ;   FOR (COUNTER = 0X19;COUNTER != 0;COUNTER--);
        GOTO    SEND_DATA_BIT_DELAY     ;74;
        NOP                             ; 1 ;
        NOP                             ; 1 ;
        DECFSZ  REG_01,SAME             ;1/2;
        GOTO    TRANSMIT_BIT            ; 2 ;   }LOOP_CYCLE_TIME : 93 CYCLES
        MOVLW   002H                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
SEND_LAST_BIT_DELAY                     ;   ;83 AFTER OUTPUT OF LAST DATA_BIT
        DECFSZ  REG_00,SAME             ;   ;FOR (COUNTER = 0X02;COUNTER != 0;COUNTER--);
        GOTO    SEND_LAST_BIT_DELAY     ;05;
        MOVLW   TRI_B_MASK & 0FFH       ; 1 ;   TXD = INPUT ( TRISTATE )
        BTFSS   PSW,PARITY              ;1/2;   OR
        MOVLW   TRI_B_MASK & 0FEH       ; 1 ;   TXD = OUTPUT  ( ACTIVE LOW )
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   01DH                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
SEND_PARITY_DELAY                       ;   ;
        DECFSZ  REG_00,SAME             ;   ;FOR (COUNTER = 0X19;COUNTER != 0;COUNTER--);
        GOTO    SEND_PARITY_DELAY       ;86;
        NOP                             ; 1 ;90 AFTER OUTPUT OF PARITY
        MOVLW   TRI_B_MASK & 0FFH       ; 1 ;   RB.0 = INPUT ( TRISTATE )
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   019H                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
SEND_STOPBIT_DELAY                      ;   ;
        DECFSZ  REG_00,SAME             ;   ;FOR (COUNTER = 0X19;COUNTER != 0;COUNTER--);
        GOTO    SEND_STOPBIT_DELAY      ;74;
        BTFSC   COM_PORT,ISOTXD         ;1/2;78 AFTER OUTPUT OF STOPBIT
        GOTO    TRANSMIT_END            ; 2 ;---> SAMPLE STOPBIT FOR PARITY_ERROR
        DECFSZ  REG_02,SAME             ;1/2;
        GOTO    TRANSMIT_BYTE           ; 2 ;
        BCF     STATUS,C                ; 1 ;PARITY_ERROR
        RETLW   0                       ; 2 ;
                                        ;   ;
TRANSMIT_END                            ;   ;
        BSF     STATUS,C                ; 1 ;
        RETLW   0                       ; 2 ;


; END OF _TRANSMIT_ISO_ASYNC

        PAGE

;**************************************************************************
;* PROGRAMMER           : THOMAS                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               :                                                 *
;* USING                : REG_00,REG_01,REG_02,REG_03(READ_BYTE),PSW      *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

;ASYNCHRONOUS COMMUNICATION CARD <-- CONTROLLER
;**********************************************

; BIT RECEIVE_ISO_ASYNC ( UNSIGNED CHAR IDATA *READ_BYTE )


RECEIVE_ISO_ASYNC
        BCF     COM_PORT,ISOTXD         ; 1 ;LOW ----> TXD LATCH
        MOVLW   00FH                    ; 1 ;
        MOVWF   REG_02                  ; 1 ;REPEAT_COUNTER = 15
RECEIVE_BYTE
        MOVLW   032H                    ; 1 ;WORK_WAITING_TIME P16C84 :
        MOVWF   REG_01                  ; 1 ;( ( 7 * 255 ) + 9 ) * 50 [CYCLES]
        CLRF    REG_00                  ; 1 ;( = 89700 CYCLES = 102,51 MS AT 3.500 MHZ )
SAMPLE_START_BIT                        ;   ;
        BTFSS   COM_PORT,ISORXD         ;1/2;BEGIN_OF_START_BIT (POSITIVE_LOGIC)
        BTFSC   COM_PORT,ISORXD         ;1/2;
        GOTO    STARTBIT_LOOP           ; 2 ;
        GOTO    STARTBIT_FOUND          ; 2 ;
STARTBIT_LOOP                           ;   ;
        DECFSZ  REG_00,SAME             ;1/2;
        GOTO    SAMPLE_START_BIT        ; 2 ;
        DECFSZ  REG_01,SAME             ;1/2;
        GOTO    SAMPLE_START_BIT        ; 2 ;
        GOTO    READ_ERROR              ; 2 ;
STARTBIT_FOUND                          ;   ;05 AFTER BEGIN OF STARTBIT
        MOVLW   008H                    ; 1 ;BIT_COUNTER = 0X08
        MOVWF   REG_01                  ; 1 ;
        CLRF    IND0                    ; 1 ;SHIFT_REGISTER = 0X00
        CLRF    PSW                     ; 1 ;
        MOVLW   029H                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;WAIT FOR END_OF_STARTBIT:
STARTBIT_DELAY                          ;   ;
        DECFSZ  REG_00,SAME             ;   ;FOR ( COUNTER = 0X29;COUNTER != 0X00;COUNTER-- );
        GOTO    STARTBIT_DELAY          ;122;
                                        ;   ;133 AFTER BEGIN OF STARTBIT
        PAGE

                                        ;   ;133 AFTER BEGIN OF STARTBIT
RECEIVE_BIT                             ;   ;READ 8 DATA_BITS:
        CLRF    REG_00                  ; 1 ;FOR ( ;BIT_COUNTER != 0X00;BIT_COUNTER-- )
        BTFSS   FLAGS,CONVENTION        ;1/2;    {
        BSF     REG_00,1                ; 1 ;   136 AFTER BEGIN OF STARTBIT
        BTFSC   COM_PORT,ISORXD         ;1/2;   SAMPLE I/O (DATA_BIT_N FIRST SAMPLE)
        INCF    REG_00,SAME             ; 1 ;   ( 44 CYCLES AFTER BEGIN OF DATA_BIT_N)
        BTFSC   COM_PORT,ISORXD         ;1/2;   SAMPLE I/O (DATA_BIT_N 2ND SAMPLE)
        INCF    REG_00,SAME             ; 1 ;
        BTFSC   COM_PORT,ISORXD         ;1/2;   SAMPLE I/O (DATA_BIT_N 3RD SAMPLE)
        INCF    REG_00,SAME             ; 1 ;
        BTFSC   REG_00,1                ;1/2;
        INCF    PSW,SAME                ; 1 ;
        BCF     STATUS,C                ; 1 ;
        BTFSC   REG_00,1                ;1/2;
        BSF     STATUS,C                ; 1 ;
        BTFSC   FLAGS,CONVENTION        ;1/2;
        RRF     IND0,SAME               ; 1 ;   ROTATE ACCU RIGHT THROUGH C
        BTFSS   FLAGS,CONVENTION        ;1/2;
        RLF     IND0,SAME               ; 1 ;   ROTATE ACCU LEFT THROUGH C
        MOVLW   017H                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
READ_DATA_BIT_DELAY                     ;20;
        DECFSZ  REG_00,SAME             ;   ;   FOR ( COUNTER = 0X12;COUNTER != 0X00;COUNTER-- );
        GOTO    READ_DATA_BIT_DELAY     ;68;
        NOP                             ; 1 ;
        NOP                             ; 1 ;
        DECFSZ  REG_01                  ;1/2;
        GOTO    RECEIVE_BIT             ; 2 ;   }LOOP_CYCLE_TIME : 93 CYCLES
        CLRF    REG_00                  ; 1 ;
        BTFSS   FLAGS,CONVENTION        ;1/2;
        BSF     REG_00,SAME             ; 1 ;READ PARITY_BIT:
        NOP                             ; 1 ;92 AFTER 1ST SAMPLE OF LAST DATA_BIT
        BTFSC   COM_PORT,ISORXD         ;1/2;SAMPLE I/O (PARITY_BIT FIRST SAMPLE)
        INCF    REG_00,SAME             ; 1 ;(44 CYCLES AFTER BEGIN OF PARITY_BIT)
        BTFSC   COM_PORT,ISORXD         ;1/2;SAMPLE I/O (PARITY_BIT 2ND SAMPLE)
        INCF    REG_00,SAME             ; 1 ;
        BTFSC   COM_PORT,ISORXD         ;1/2;SAMPLE I/O (PARITY_BIT 3RD SAMPLE)
        INCF    REG_00,SAME             ; 1 ;
        BTFSS   PSW,PARITY              ;1/2;ODD :IF(PSW.PARITY && !ISORXD) -> PARITY_ERROR
        COMF    REG_00,SAME             ; 1 ;EVEN:IF(!PSW.PARITY && ISORXD) -> PARITY_ERROR
        BTFSS   REG_00,1                ;1/2;
        GOTO    PARITY_ERROR            ; 2 ;
        MOVLW   038H                    ; 1 ;
        MOVWF   REG_00                  ; 1 ;
READ_STOPBIT_DELAY                      ;   ;
        DECFSZ  REG_00,SAME             ;   ;FOR ( COUNTER = 0X13;COUNTER != 0X00;COUNTER-- );
        GOTO    READ_STOPBIT_DELAY      ;167;
        MOVF    IND0,WREG               ; 1 ;
        MOVWF   READ_BYTE               ; 1 ;
        ADDWF   CHECKSUM,SAME           ; 1 ;CHECKSUM + = *FSR
        INCF    FSR                     ; 1 ;
        BSF     STATUS,C                ; 1 ;
        RETLW   0                       ; 2 ;185 AFTER 1ST SAMPLE OF PARITY

        PAGE

PARITY_ERROR                            ;   ;10 AFTER 1ST SAMPLE OF PARITY
        MOVLW   018H                    ; 1 ;(54 CYCLES AFTER BEGIN OF PARITY)
        MOVWF   REG_00                  ; 1 ;
READ_PARITY_DELAY                       ;   ;
        DECFSZ  REG_00,SAME             ;   ;FOR ( COUNTER = 0X14;COUNTER != 0X00;COUNTER-- );
        GOTO    READ_PARITY_DELAY       ;71;
        MOVLW   TRI_B_MASK & 0FEH       ; 1 ;   RB.0 = OUTPUT ( ACTIVE LOW )
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVLW   014H                    ; 1 ;---> PARITY_ERROR !!!!!!!!!!!!
        MOVWF   REG_00                  ; 1 ;
READ_STOPBIT_DELAY1                     ;   ;
        DECFSZ  REG_00,SAME             ;   ;FOR ( COUNTER = 0X1F;COUNTER != 0X00;COUNTER-- );
        GOTO    READ_STOPBIT_DELAY1     ;59;
        MOVLW   TRI_B_MASK & 0FFH       ; 1 ;   RB.0 = INPUT ( TRISTATE )
        BSF     STATUS,RP0              ; 1 ;   PAGE SELECT
        MOVWF   TRISB                   ; 1 ;   SET DATA DIRECTION
        BCF     STATUS,RP0              ; 1 ;   PAGE SELECT
        DECFSZ  REG_02                  ;1/2;---> ISORXD IDLE
        GOTO    RECEIVE_BYTE            ; 2 ;
READ_ERROR                              ;   ;
        BCF     STATUS,C                ; 1 ;
        RETLW   0                       ; 2 ;

; END OF _RECEIVE_ISO_ASYNC


        PAGE

;**************************************************************************
;* PROGRAMMER           : THOMAS                                          *
;* DATE                 :                                                 *
;**************************************************************************
;* MODULE               :                                                 *
;* USING                :                                                 *
;* INPUT PARAMETERS     :                                                 *
;* OUTPUT PARAMETERS    :                                                 *
;* DESCRIPTION          :                                                 *
;**************************************************************************

WREE_C_MODE
        BCF     INTCON,GIE              ; 1 ; CLOSE ALL INTERRUPTS
        MOVLW   C_MODE_EE_ADR           ; 1 ;
        MOVWF   EEADR                   ; 1 ; PREPARE ADDRESS
        MOVF    C_MODE,WREG             ; 1 ;
        MOVWF   EEDATA                  ; 1 ; PREPARE DATA
        BSF     STATUS,RP0              ; 1 ;PAGE 1 +++++
        BSF     EECON1,EE_WREN          ; 1 ; ENABLE WRITE
EEWRITE                                 ;   ;
        MOVLW   055H                    ; 1 ; WRITE SEQUENCE
        MOVWF   EECON2                  ; 1 ;
        MOVLW   0AAH                    ; 1 ;
        MOVWF   EECON2                  ; 1 ;
        BSF     EECON1,EE_WR            ; 1 ; SET WR BIT
WAIT_EE                                 ;   ; BEGIN WRITE
        BTFSC   EECON1,EE_WR            ; 1 ;
        GOTO    WAIT_EE                 ; 2 ; WAIT FOR WRITE COMPLETE
        BCF     EECON1,EE_EEIF          ; 1 ; CLEAR EEIF FLAG
        BCF     EECON1,EE_WREN          ; 1 ; DISABLE WRITE
        BCF     STATUS,RP0              ; 1 ;PAGE 0 +++++
        RETURN                          ; 1 ;

;       ORG     2000H                   ;   ; ID 1...4
;       DATA    000H                    ;   ;
;       DATA    000H                    ;   ;
;       DATA    001H                    ;   ;

;       ORG     2007H                   ;   ; CONFIGURATION WORD
;       DATA    011H                    ;   ; XT OSZ.; WD OFF; PWRTE OFF;
                                        ;   ; CP ON
        END









